<?php

/**
 * @file
 * Post update functions for Search API Best Bets.
 */

use Drupal\Core\Config\Entity\ConfigEntityUpdater;
use Drupal\Core\Entity\Display\EntityFormDisplayInterface;

/**
 * Converts 'disable_exclude' setting to boolean.
 */
function search_api_best_bets_post_update_set_disable_exclude(array &$sandbox): void {
  \Drupal::classResolver(ConfigEntityUpdater::class)->update($sandbox, 'entity_form_display', function (EntityFormDisplayInterface $form_display): bool {
    $changed = FALSE;

    foreach ($form_display->getComponents() as $field => $component) {
      if (isset($component['type']) && $component['type'] === 'search_api_best_bets_widget') {
        $component['settings']['disable_exclude'] = (bool) $component['settings']['disable_exclude'];
        $form_display->setComponent($field, $component);
        $changed = TRUE;
      }
    }
    return $changed;
  });
}
